      * Generated on 1/11/2022 at 4:00:43 PM
      *
      *|COMPONENT INFO:
      *|Component type: Structure Based Slice: Range
      *|Original program: "BBANK70P"
      *|COBOL dialect: Cobol390

      *|COMPONENT TYPE SPECIFIC:
      *|Start Paragraph: _PAR_LOAN-CALCULATION
      *|Last Paragraph: _PAR_LOAN-CALCULATION

      *|THIS IS THE LAST LINE OF GENERATED HEADER

      *****************************************************************
      *                                                               *
      * Copyright (C) 2010-2021 Micro Focus.  All Rights Reserved     *
      * This software may be used, modified, and distributed          *
      * (provided this notice is included without modification)       *
      * solely for internal demonstration purposes with other         *
      * Micro Focus software, and is otherwise subject to the EULA at *
      * https://www.microfocus.com/en-us/legal/software-licensing.    *
      *                                                               *
      * THIS SOFTWARE IS PROVIDED "AS IS" AND ALL IMPLIED             *
      * WARRANTIES, INCLUDING THE IMPLIED WARRANTIES OF               *
      * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE,         *
      * SHALL NOT APPLY.                                              *
      * TO THE EXTENT PERMITTED BY LAW, IN NO EVENT WILL              *
      * MICRO FOCUS HAVE ANY LIABILITY WHATSOEVER IN CONNECTION       *
      * WITH THIS SOFTWARE.                                           *
      *                                                               *
      *****************************************************************

      *****************************************************************
      * Program:     BBANK70P.CBL                                     *
      * Layer:       Business logic                                   *
      * Function:    Calculate cost of loan                           *
      *****************************************************************
       IDENTIFICATION DIVISION.
       PROGRAM-ID. LOANCALC.

       ENVIRONMENT DIVISION.

       DATA DIVISION.
       WORKING-STORAGE SECTION.
       01 WS-MISC-STORAGE.
         05 WS-PROGRAM-ID PIC X(8) VALUE 'BBANK70P'.
         05 WS-INPUT-FLAG PIC X(1).
           88 INPUT-OK VALUE '0'.
           88 INPUT-ERROR VALUE '1'.
         05 WS-RETURN-FLAG PIC X(1).
           88 WS-RETURN-FLAG-OFF VALUE LOW-VALUES.
           88 WS-RETURN-FLAG-ON VALUE '1'.
         05 WS-RETURN-MSG PIC X(75).
           88 WS-RETURN-MSG-OFF VALUE SPACES.
         05 WS-PFK-FLAG PIC X(1).
           88 PFK-VALID VALUE '0'.
           88 PFK-INVALID VALUE '1'.
         05 WS-ERROR-MSG PIC X(75).
      *
         05 WS-CALC-WORK-AREAS.
      * Used to count no of periods in rate
           10 WS-CALC-WORK-RATE-PERIOD PIC 9(1).
      * Generate work area
           10 WS-CALC-WORK-TEMP PIC X(7).
      * Work area for AMOUNT
           10 WS-CALC-WORK-AMOUNT PIC X(7).
           10 WS-CALC-WORK-AMOUNT-N REDEFINES WS-CALC-WORK-AMOUNT
                                    PIC 9(7).
      * Work area for RATE
           10 WS-CALC-WORK-RATE PIC X(7).
      * Used to hold first part of rate (before the period)
           10 WS-CALC-WORK-RATE-P1 PIC X(6).
           10 WS-CALC-WORK-RATE-P1-N REDEFINES WS-CALC-WORK-RATE-P1
                                     PIC 9(6).
      * Used to hold second part of rate (before the period)
           10 WS-CALC-WORK-RATE-P2 PIC X(6).
           10 WS-CALC-WORK-RATE-P2-N REDEFINES WS-CALC-WORK-RATE-P2
                                     PIC 9(6).
      * Used to hold rate as percentage (xxxvxxx)
           10 WS-CALC-WORK-PERC PIC X(6).
           10 WS-CALC-WORK-PERC-N REDEFINES WS-CALC-WORK-PERC
                                  PIC 9(3)V9(3).
      * Work area for TERM
           10 WS-CALC-WORK-TERM PIC X(5).
           10 WS-CALC-WORK-TERM-N REDEFINES WS-CALC-WORK-TERM PIC 9(5).
      * Work area for PAYMENT
           10 WS-CALC-WORK-PAYMENT PIC X(9).
           10 WS-CALC-WORK-PAYMENT-N REDEFINES WS-CALC-WORK-PAYMENT
                                     PIC $$$$$9.99.
EXER01* Work area for TOTAL
EXER01     10 WS-CALC-WORK-TOTAL PIC X(9).
EXER01     10 WS-CALC-WORK-TOTAL-N REDEFINES WS-CALC-WORK-TOTAL
                                   PIC $$$$$9.99.

         05 WS-LOAN-AREAS.
           10 WS-LOAN-PRINCIPAL PIC S9(7).
           10 WS-LOAN-INTEREST PIC SV9(8).
           10 WS-LOAN-TERM PIC S9(5).
           10 WS-LOAN-MONTHLY-PAYMENT PIC S9(6)V99.
EXER01     10 WS-LOAN-TOTAL-PAYMENT PIC S9(6)V99.
       LINKAGE SECTION.
       01 BRE-INP-INPUT-STRUCTURE.
         02 BRE-I-WS-LOAN-PRINCI PIC S9(7).
         02 BRE-I-WS-LOAN-INTERE PIC SV9(8).
         02 BRE-I-WS-LOAN-TERM PIC S9(5).
       01 BRE-OUT-OUTPUT-STRUCTURE.
         02 BRE-O-WS-LOAN-MONTHL PIC S9(6)V99.
         02 BRE-O-WS-LOAN-TOTAL PIC S9(6)V99.
      *****************************************************************
      *                                                               *
      * Copyright (C) 2010-2021 Micro Focus.  All Rights Reserved     *
      * This software may be used, modified, and distributed          *
      * (provided this notice is included without modification)       *
      * solely for internal demonstration purposes with other         *
      * Micro Focus software, and is otherwise subject to the EULA at *
      * https://www.microfocus.com/en-us/legal/software-licensing.    *
      *                                                               *
      * THIS SOFTWARE IS PROVIDED "AS IS" AND ALL IMPLIED             *
      * WARRANTIES, INCLUDING THE IMPLIED WARRANTIES OF               *
      * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE,         *
      * SHALL NOT APPLY.                                              *
      * TO THE EXTENT PERMITTED BY LAW, IN NO EVENT WILL              *
      * MICRO FOCUS HAVE ANY LIABILITY WHATSOEVER IN CONNECTION       *
      * WITH THIS SOFTWARE.                                           *
      *                                                               *
      *****************************************************************

      *****************************************************************
      * CENTRY.CPY (CICS Version)                                     *
      *---------------------------------------------------------------*
      * This copybook is used to provide an entry point for modules   *
      * so that they may be insensitive to their environment.         *
      * There are different versions for CICS, IMS and INET.          *
      *****************************************************************
       PROCEDURE DIVISION USING BRE-INP-INPUT-STRUCTURE
                                BRE-OUT-OUTPUT-STRUCTURE.
      * $ Version 5.99c sequenced on Wednesday 3 Mar 2011 at 1:00pm
           PERFORM BRE-COPY-INPUT-DATA-0
           .
           PERFORM PAR-LOAN-CALCULATION
           .
           PERFORM BRE-COPY-OUTPUT-DATA
           .
           GOBACK
           .
      * $ Version 5.99c sequenced on Wednesday 3 Mar 2011 at 1:00pm
       LOAN-CALCULATION SECTION.
       PAR-LOAN-CALCULATION.
EXER02     DIVIDE WS-LOAN-INTEREST BY 12
             GIVING WS-LOAN-INTEREST ROUNDED
EXER02     .
EXER02     COMPUTE WS-LOAN-MONTHLY-PAYMENT ROUNDED =
             ((WS-LOAN-INTEREST * ((1 + WS-LOAN-INTEREST)
EXER02                             ** WS-LOAN-TERM)) /
EXER02        (((1 + WS-LOAN-INTEREST) ** WS-LOAN-TERM) - 1))
EXER02       * WS-LOAN-PRINCIPAL
EXER02     .
EXER02     COMPUTE WS-LOAN-TOTAL-PAYMENT =
             (WS-LOAN-MONTHLY-PAYMENT * WS-LOAN-TERM)
EXER02     .
       BRE-EXIT-PROGRAM-SECTION SECTION.
       BRE-COPY-INPUT-DATA-0.
           MOVE BRE-I-WS-LOAN-PRINCI TO WS-LOAN-PRINCIPAL
           MOVE BRE-I-WS-LOAN-INTERE TO WS-LOAN-INTEREST
           MOVE BRE-I-WS-LOAN-TERM TO WS-LOAN-TERM
           .
       BRE-COPY-OUTPUT-DATA.
           MOVE WS-LOAN-MONTHLY-PAYMENT TO BRE-O-WS-LOAN-MONTHL
           MOVE WS-LOAN-TOTAL-PAYMENT TO BRE-O-WS-LOAN-TOTAL
           .
